/*
 * ll_consolehandler.cpp
 *
 *  Created on: Nov 7, 2019
 *      Author: abody
 */

#include <f1ll/console_handler.h>

#include <string.h>

namespace f1ll {

console_handler::console_handler(USART_TypeDef *usart, DMA_TypeDef *dma, uint32_t channelRx, uint32_t channelTx)
    : usart_core(usart, dma, channelRx, channelTx)
{
}

void console_handler::receiver_idle(void) {}
void console_handler::transmission_complete(void)
{
  m_busy = false;
  m_used = 0;
}
void console_handler::framing_error(void) {}
void console_handler::overrun(void) {}
void console_handler::rx_dma_transfer_complete(void) {}
void console_handler::rx_dma_half_transfer(void) {}
void console_handler::rx_dma_error(void) {}
void console_handler::tx_dma_transfer_complete(void)
{
  LL_USART_EnableIT_TC(m_usart);
  LL_DMA_DisableChannel(m_txDma.get_dma(), m_txDma.get_channel());
}
void console_handler::tx_dma_half_transfer(void) {}
void console_handler::tx_dma_error(void) {}

void console_handler::append(char const *s)
{
  while (m_busy)
    ;
  size_t len = strlen(s);
  size_t max_len = sizeof(m_buffer) - m_used;
  strncpy(m_buffer + m_used, s, max_len);
  m_used += len < max_len ? len : max_len;
}

void console_handler::flush()
{
  while (m_busy)
    ;

  if (m_used) {
    m_busy = true;
    setup_transmit(m_buffer, m_used);
  }
}

void console_handler::print(char const *s)
{
  append(s);
  flush();
}

} // namespace f1ll
